{-# LANGUAGE OverloadedStrings #-}

module WaiApp (waiApplication, WSA.newServerState, WSA.ServerState) where
  
import qualified WebSocketApp as WSA
import qualified Network.WebSockets as WS
import Network.Wai.Handler.WebSockets
import Network.Wai
import Network.HTTP.Types
import Control.Concurrent.MVar
import qualified Colog as Log

waiApplication :: Log.LogAction IO Log.Message ->MVar WSA.ServerState -> Application
waiApplication logAction serverState = websocketsOr WS.defaultConnectionOptions (WSA.application logAction serverState) clientServer

-- this should serve the webclient see Network.Wai.responseFile
clientServer :: Application
clientServer _ respond = respond $ responseLBS status404 [] "No webclient implemented (Franzi essen ?? -- Emma)"
